HDU 4451 Dressing(组合数学 + 容斥)

传送门:HDU 4451

题面:

Wangpeng has N clothes, M pants and K shoes so theoretically he can have N×M×K different combinations of dressing. 
One day he wears his pants Nike, shoes Adiwang to go to school happily. When he opens the door, his mom asks him to come back and switch the dressing. Mom thinks that pants-shoes pair is disharmonious because Adiwang is much better than Nike. After being asked to switch again and again Wangpeng figure out all the pairs mom thinks disharmonious. They can be only clothes-pants pairs or pants-shoes pairs. 
Please calculate the number of different combinations of dressing under mom’s restriction.

Input

There are multiple test cases. 
For each case, the first line contains 3 integers N,M,K(1≤N,M,K≤1000) indicating the number of clothes, pants and shoes. 
Second line contains only one integer P(0≤P≤2000000) indicating the number of pairs which mom thinks disharmonious. 
Next P lines each line will be one of the two forms“clothes x pants y” or “pants y shoes z”. 
The first form indicates pair of x-th clothes and y-th pants is disharmonious(1≤x≤N,1 ≤y≤M), and second form indicates pair of y-th pants and z-th shoes is disharmonious(1≤y≤M,1≤z≤K). 
Input ends with “0 0 0”. 
It is guaranteed that all the pairs are different.

Output

For each case, output the answer in one line.

Sample Input

2 2 2
0
2 2 2
1
clothes 1 pants 1
2 2 2
2
clothes 1 pants 1
pants 1 shoes 1
0 0 0

Sample Output

8
6
5

题意:

给出衣服裤子袜子的种类数量,求搭配数量,当然有的衣服与裤子不能搭配,有的裤子和袜子不能搭配。

思路:

显然,这是有个组合数学问题,先算出总的搭配数,然后对于不可选搭配进行容斥。

AC代码:

#include<bits/stdc++.h>
typedef long long ll;
typedef unsigned long long ull;
using namespace std;
const int N = 2e6 + 7;
const double pi = acos(-1);
const int mod = 1e9 + 7;
const int inf = 0x3f3f3f3f;
int in[N],out[N];
int main(){
    int a,b,c,p,op1,op2;
    while(scanf("%d%d%d",&a,&b,&c) != EOF && a && b && c){
        scanf("%d",&p);
        memset(in,0,sizeof in);
        memset(out,0,sizeof out);
        char b1[10],b2[10];
        int pos = a * b * c,cnt1 = 0,cnt2 = 0;
        while(p--){
            scanf("%s%d%s%d",b1,&op1,b2,&op2);
            if(b1[0] == 'c'){
                in[op2]++;
                cnt1++;
            }
            else{
                out[op1]++;
                cnt2++;
            }
        }
        pos -= (cnt1 * c + cnt2 * a);
        for(int i = 1;i <= b;++i){
            pos += in[i] * out[i];
        }
        printf("%d\n",pos);
    }
    return 0;
}

猜你喜欢

转载自blog.csdn.net/qq_41791981/article/details/82902542
今日推荐